# -*- coding: utf-8 -*-
#
# File: LinguaLink.py
#
# Copyright (c) 2006 by BlueDynamics Alliance, Klein & Partner KEG, Austria
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens W. Klein <jens@bluedynamics.com>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.BlueLinguaLink.config import *

##code-section module-header #fill in your manual code here
from Products.Archetypes import config as atconfig
from Products.CMFCore import permissions
##/code-section module-header

copied_fields = {}
copied_fields['description'] = BaseSchema['description'].copy()
copied_fields['description'].schemata = "default"
copied_fields['description'].isMetadata = False
schema = Schema((

    copied_fields['description'],
    ),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

LinguaLink_schema = BaseSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
actions=(
    {
    'id'          : 'view',
    'name'        : 'View',
    'action'      : 'string:${object_url}',
    'permissions' : ('View',)
    },
    {
    'id'          : 'edit',
    'name'        : 'Edit',
    'action'      : 'string:${object_url}/edit',
    'permissions' : ('Modify portal content',),
    },
)

aliases = {
    '(Default)'  : '(dynamic view)',
    'view'       : '(selected layout)',
    'index.html' : '(dynamic view)',
    'edit'       : 'base_edit',
    'properties' : 'base_metadata',
    }
##/code-section after-schema

class LinguaLink(BaseContent, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'LinguaLink'

    meta_type = 'LinguaLink'
    portal_type = 'LinguaLink'
    allowed_content_types = [] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    content_icon = 'flag-plone.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "LinguaLink"
    typeDescMsgId = 'description_edit_lingualink'

    _at_rename_after_creation = True

    schema = LinguaLink_schema

    ##code-section class-header #fill in your manual code here
    aliases = aliases
    actions = actions
    ##/code-section class-header

    # Methods

    security.declareProtected(permissions.View, 'getLinkTarget')
    def getLinkTarget(self):
        """returns neutral content"""
        refs = self.getRefs('lingualink')
        #import pdb; pdb.set_trace()
        if not refs:
            return None
        obj = refs[0]
        return obj

    security.declarePrivate('setLanguageNeutral')
    def setLanguageNeutral(self, neutralObject):
        """Sets the reference to neutral content."""
        self.deleteReferences('lingualink')
        self.addReference(neutralObject, 'lingualink')

    security.declareProtected(permissions.View, 'getRemoteUrl')
    def getRemoteUrl(self):
        """returns absolute placeless url of neutral content."""
        obj = self.getLinkTarget()
        if obj is None:
            return ''
        return obj.reference_url()

    security.declareProtected(permissions.View, 'setLinguaLink')
    def setLinguaLink(self, target, lang):
        """Sets a reference and the language of this object."""
        self.setLanguage(lang)
        self.setLanguageNeutral(target)


registerType(LinguaLink, PROJECTNAME)
# end of class LinguaLink

##code-section module-footer #fill in your manual code here
##/code-section module-footer



