# -*- coding: utf-8 -*-
#
# Copyright (c) 2006 by BlueDynamics Alliance, Klein & Partner KEG, Austria
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
__author__ = """Jens W. Klein <jens@bluedynamics.com>"""
__docformat__ = 'plaintext'

from zope.interface import Interface

class ILinguaLink(Interface):
    """Defines methods on LinguaLink Objects. """
    
    def getRemoteUrl():
        """returns url of neutral content."""        
        
    def setLinguaLink(target, lang):
        """Sets the target and the language of this object."""
        
class ILinguaLinkPortlet(Interface):
    """methods to render a portlet for LinguaLinks."""
    
    def performActions():
        """check request and do whats needed."""
        
    def getUnprocessedLanguages(self):
        """returns list of lang-codes with all untranslated and not linked."""        
    
    def createLinguaLinks():
        """Creates LinguaLinks for the context."""    
    
    def isLinguaLink():
        """check if the context is a LinguaLink."""
        
    def isTranslatable():
        """check if the context is translateable."""
        
    def hasTranslations():
        """check if context is already translated."""    

    def isTranslatedToAllLanguages():
        """check if translations are complete."""
        
    def getLinguaLinks():
        """returns all LinguaLinks."""        
        
        